package com.persagy.dmp.rwd.edit.controller;

import com.persagy.dmp.rwd.edit.service.DownloadService;
import lombok.extern.slf4j.Slf4j;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.ss.usermodel.Workbook;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletResponse;
import java.io.BufferedInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.URLEncoder;

@Slf4j
@RestController
@RequestMapping("/rwdedit/common")
public class DownloadController {

    public final Logger logger = LoggerFactory.getLogger(DownloadController.class);

    @Autowired
    private DownloadService downloadService;

//    @GetMapping("/download")
//    private void download(@RequestParam String type, HttpServletResponse response) {
//        DownloadModel result = downloadService.download(type);
//        if ("workbook".equalsIgnoreCase(result.getType())) {
//            String fileName = result.getName();
//            downloadWorkbook(response, fileName, result.getWorkbook());
//        }
//    }

    @GetMapping("/download")
    private void download(@RequestParam String type, HttpServletResponse response) throws Exception {
        //读取文件
        InputStream resourceAsStream = Thread.currentThread().getContextClassLoader().getResourceAsStream("siatic/file/批量上传变更记录模板.xlsx");
        String fileName = "批量上传变更记录模板.xlsx";
        InputStream inputStream = new BufferedInputStream(resourceAsStream);
        @SuppressWarnings("resource")
        HSSFWorkbook workbook = new HSSFWorkbook(inputStream);
        // 非IE浏览器的处理：
        fileName = new String(fileName.getBytes("UTF-8"), "ISO-8859-1");
        response.setHeader("Content-disposition", "attachment; filename=" + fileName);
        response.setContentType("application/vnd.ms-excel; charset=utf-8");
        response.setCharacterEncoding("UTF-8");
        // 将流中内容写出去
        OutputStream outputStream = response.getOutputStream();
        workbook.write(outputStream);
        outputStream.flush();
        outputStream.close();
    }

    private void downloadWorkbook(HttpServletResponse resp, String fileName, Workbook workbook) {
        OutputStream out = null;
        try {
            resp.reset();// 清空输出流
            String resultFileName = URLEncoder.encode(fileName, "UTF-8");
            resp.setCharacterEncoding("UTF-8");
            resp.setHeader("Content-disposition", "attachment; filename=" + resultFileName);// 设定输出文件头
            resp.setContentType("application/vnd.ms-excel; charset=utf-8");// 定义输出类型
            out = resp.getOutputStream();
            workbook.write(out);
            out.flush();
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            try {
                if (out != null) {
                    out.close();
                }
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }
}
